Bug 1645811 - Review Request: fcgiwrap - Simple FastCGI wrapper for CGI scripts
Summary: Review Request: fcgiwrap - Simple FastCGI wrapper for CGI scripts
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Robert-André Mauchin 🐧
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2018-11-03 23:49 UTC by Andrew Bauer
Modified: 2018-12-01 02:45 UTC (History)
2 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2018-11-27 02:27:15 UTC
Type: ---
zebob.m: fedora-review+


Attachments (Terms of Use)

Description Andrew Bauer 2018-11-03 23:49:55 UTC
Fedora Account System Username: kni

Spec URL: https://raw.githubusercontent.com/knight-of-ni/specfiles/master/fcgiwrap.spec

SRPM URL: https://kojipkgs.fedoraproject.org//work/tasks/9163/30649163/fcgiwrap-1.1.0-6.20150530git99c942c.fc30.src.rpm

Description:
-------------
This package provides a simple FastCGI wrapper for CGI scripts with/
following features:
 - very lightweight (84KB of private memory per instance)
 - fixes broken CR/LF in headers
 - handles environment in a sane way (CGI scripts get HTTP-related environment
   vars from FastCGI parameters and inherit all the others from
   environment of fcgiwrap )
 - no configuration, so you can run several sites off the same
   fcgiwrap pool
 - passes CGI std error output to std error stream of cgiwrap or FastCGI
 - support systemd socket activation, launcher program like spawn-fcgi
   is no longer required on systemd-enabled distributions

RPMLINT:
--------
$ rpmlint fcgiwrap-1.1.0-6.20150530git99c942c.fc28.src.rpm
fcgiwrap.src: W: spelling-error %description -l en_US cgiwrap -> wrapping
fcgiwrap.src: W: spelling-error %description -l en_US systemd -> systems, system, system d
fcgiwrap.src: W: spelling-error %description -l en_US fcgi -> GIF
1 packages and 0 specfiles checked; 0 errors, 3 warnings.

$ rpmlint fcgiwrap-1.1.0-6.20150530git99c942c.fc28.x86_64.rpm
fcgiwrap.x86_64: W: spelling-error %description -l en_US cgiwrap -> wrapping
fcgiwrap.x86_64: W: spelling-error %description -l en_US fcgi -> GIF
1 packages and 0 specfiles checked; 0 errors, 2 warnings.

NOTES:
------
The package in this review is based on the package with the same name by jorti, found here:
https://copr.fedorainfracloud.org/coprs/jorti/fcgiwrap/

The systemd unit files have been modified to read from an environment file.

The environment file allows one to set daemon parameters w/o editing the service file. 

Unfortunately, I have not found a way to handle the user & group names in the same manner so if the user is using a web server other than nginx, the service file must still be edited.

Comment 1 Andrew Bauer 2018-11-04 02:44:03 UTC
Updated specfile and source rpm:

https://raw.githubusercontent.com/knight-of-ni/specfiles/master/fcgiwrap.spec

https://kojipkgs.fedoraproject.org//work/tasks/1763/30651763/fcgiwrap-1.1.0-6.20150530git99c942c.fc30.src.rpm

Had to put back the --with-systemd configure flag, even though we are supplying our own systemd service files.

Comment 2 Andrew Bauer 2018-11-04 20:45:00 UTC
Converted the systemd unit files to instantiated service files. This allows one to run fcgiwrap under an arbitrary user account, which under normal circumstances will be the name of the web server user account in use on the system. 

To enable and start fcgiwrap on a system with nginx, do this:

$ systemctl enable fcgiwrap@nginx.service
$ systemctl start fcgiwrap@nginx.service


Updated specfiles and source rpm:

https://raw.githubusercontent.com/knight-of-ni/specfiles/master/fcgiwrap.spec

https://kojipkgs.fedoraproject.org//work/tasks/1241/30671241/fcgiwrap-1.1.0-6.20150530git99c942c.fc30.src.rpm

Comment 3 Andrew Bauer 2018-11-04 20:47:10 UTC
Here are the contents of the service files included with the package:

fcgiwrap@.service
------------------
[Unit]
Description=Simple CGI Server
After=nss-user-lookup.target

[Service]
EnvironmentFile=/etc/sysconfig/fcgiwrap
ExecStart=/usr/sbin/fcgiwrap ${DAEMON_OPTS} -c ${DAEMON_PROCS} 
User=%i
Group=%i

[Install]
Also=fcgiwrap@%i.socket

fcgiwrap@.socket
----------------
[Unit]
Description=fcgiwrap Socket

[Socket]
ListenStream=/run/fcgiwrap.sock
SocketUser=%i
SocketMode=0660

[Install]
WantedBy=sockets.target

Comment 4 Robert-André Mauchin 🐧 2018-11-08 10:49:24 UTC
 - Group: is not used in Fedora

 - date should be the date you took the snapshot, not the date of the commit

Package approved, fix the above issues before import.


Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed



===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: If your application is a C or C++ application you must list a
     BuildRequires against gcc, gcc-c++ or clang.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "Unknown or generated", "Expat License". 7 files have unknown
     license. Detailed output of licensecheck in
     /home/bob/packaging/review/fcgiwrap/review-fcgiwrap/licensecheck.txt
[x]: License file installed when any subpackage combination is installed.
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[x]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 10240 bytes in 2 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package does not own files or directories owned by other packages.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: %config files are marked noreplace or the reason is justified.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: No %config files under /usr.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: systemd_post is invoked in %post, systemd_preun in %preun, and
     systemd_postun in %postun for Systemd service files.
     Note: Systemd service file(s) in fcgiwrap
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[-]: Fully versioned dependency in subpackages if applicable.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in
     fcgiwrap-debuginfo , fcgiwrap-debugsource
[?]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: Patches link to upstream bugs/comments/lists or are otherwise
     justified.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[-]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on debuginfo package(s).
     Note: No rpmlint messages.
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Large data in /usr/share should live in a noarch subpackage if package
     is arched.
[x]: Package should not use obsolete m4 macros
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: fcgiwrap-1.1.0-6.20150530git99c942c.fc30.x86_64.rpm
          fcgiwrap-debuginfo-1.1.0-6.20150530git99c942c.fc30.x86_64.rpm
          fcgiwrap-debugsource-1.1.0-6.20150530git99c942c.fc30.x86_64.rpm
          fcgiwrap-1.1.0-6.20150530git99c942c.fc30.src.rpm
fcgiwrap.x86_64: W: spelling-error %description -l en_US cgiwrap -> wrapping
fcgiwrap.x86_64: W: spelling-error %description -l en_US fcgi -> GIF
fcgiwrap.src: W: spelling-error %description -l en_US cgiwrap -> wrapping
fcgiwrap.src: W: spelling-error %description -l en_US systemd -> systems, system, system d
fcgiwrap.src: W: spelling-error %description -l en_US fcgi -> GIF
4 packages and 0 specfiles checked; 0 errors, 5 warnings.

Comment 6 Gwyn Ciesla 2018-11-08 19:45:58 UTC
(fedscm-admin):  The Pagure repository was created at https://src.fedoraproject.org/rpms/fcgiwrap

Comment 7 Fedora Update System 2018-11-08 23:06:16 UTC
fcgiwrap-1.1.0-7.20181108git99c942c.fc28 has been submitted as an update to Fedora 28. https://bodhi.fedoraproject.org/updates/FEDORA-2018-ea5776974f

Comment 8 Fedora Update System 2018-11-08 23:06:55 UTC
fcgiwrap-1.1.0-7.20181108git99c942c.fc29 has been submitted as an update to Fedora 29. https://bodhi.fedoraproject.org/updates/FEDORA-2018-da190af820

Comment 9 Fedora Update System 2018-11-09 07:46:07 UTC
fcgiwrap-1.1.0-7.20181108git99c942c.fc29 has been pushed to the Fedora 29 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2018-da190af820

Comment 10 Fedora Update System 2018-11-09 07:51:06 UTC
fcgiwrap-1.1.0-7.20181108git99c942c.fc28 has been pushed to the Fedora 28 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2018-ea5776974f

Comment 11 Fedora Update System 2018-11-15 21:35:25 UTC
fcgiwrap-1.1.0-7.20181108git99c942c.fc27 has been submitted as an update to Fedora 27. https://bodhi.fedoraproject.org/updates/FEDORA-2018-19296d2898

Comment 12 Fedora Update System 2018-11-15 21:42:28 UTC
fcgiwrap-1.1.0-7.20181108git99c942c.el7 has been submitted as an update to Fedora EPEL 7. https://bodhi.fedoraproject.org/updates/FEDORA-EPEL-2018-b07b908607

Comment 13 Fedora Update System 2018-11-16 04:34:39 UTC
fcgiwrap-1.1.0-7.20181108git99c942c.fc27 has been pushed to the Fedora 27 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2018-19296d2898

Comment 14 Fedora Update System 2018-11-16 06:11:30 UTC
fcgiwrap-1.1.0-7.20181108git99c942c.el7 has been pushed to the Fedora EPEL 7 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-EPEL-2018-b07b908607

Comment 15 Fedora Update System 2018-11-27 02:27:15 UTC
fcgiwrap-1.1.0-7.20181108git99c942c.fc28 has been pushed to the Fedora 28 stable repository. If problems still persist, please make note of it in this bug report.

Comment 16 Fedora Update System 2018-11-27 03:30:23 UTC
fcgiwrap-1.1.0-7.20181108git99c942c.fc29 has been pushed to the Fedora 29 stable repository. If problems still persist, please make note of it in this bug report.

Comment 17 Fedora Update System 2018-11-27 17:11:51 UTC
fcgiwrap-1.1.0-7.20181108git99c942c.fc28 has been pushed to the Fedora 28 stable repository. If problems still persist, please make note of it in this bug report.

Comment 18 Fedora Update System 2018-12-01 02:45:45 UTC
fcgiwrap-1.1.0-7.20181108git99c942c.el7 has been pushed to the Fedora EPEL 7 stable repository. If problems still persist, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.